/* $Id: cvs_header.js,v1.1 2002/10/18 08:12:56 StormShadow Exp $ */

/*
* File:			cvs_header.js
* Description:	HomeSite CVS Header - inserts a cvs style header comment
* Author:		Robert J Sherman SnR Graphics http://www.snr-graphics.com/
*
* Comments:		This script "assumes" you are updating the CVS header just-prior to "check-in" of
* 				the file, since a check-in increments the minor revision in CVS, this operation
* 				will auto-matically increment the minor revision number, it "does not" update
* 				the major revision.
*	
* 				Example, the file being edited is revision (,v1.10).
* 				the call to this script will update the revision to (,v1.11).
*/
function Main() {
	var app = Application;
	var active = app.ActiveDocument;
	var insertString = new String();
	var curDate = new Date();
	var WSHNetwork = new ActiveXObject("WScript.Network");
	var curFile = active.Filename;
	var curExt = new String();
	var created = new Date();
	if (curFile.length > 0) {
		curExt = curFile.substring(curFile.lastIndexOf(".") + 1, curFile.length).toLowerCase();
		// get the current file's last-modified date
		var protocol = curFile.substring(0,6).toLowerCase();
		if (protocol != "ftp://" && protocol != "rds://") {
			// can only get the creation date on local files
			var objFileSys = new ActiveXObject("Scripting.FileSystemObject");
			var objFile = objFileSys.GetFile(curFile);
			created = new Date(Date.parse(objFile.DateCreated));
			objFile = null;
			objFileSys = null;
			}
		}

	var headerBegin = new String();
	var headerEnd = new String();
	var lineBegin = new String();
	
	switch (curExt) {
		case "html":
		case "htm":
		case "shtm":
		case "shtml":
		case "dwt":
		case "xml":
		case "css":
		case "form":
			headerBegin = "<!-- $Id:";
			headerEnd = " Exp $ -->";
			break;
		case "js":
		case "php":
		case "inc":
		case "fnc":
		case "class":
			headerBegin = "/* $Id:";
			headerEnd = " Exp $ */";
			break;
		default:
			headerBegin = "/* $Id:";
			headerEnd = " Exp $ */";
			break;
		}
	
	// Insert header inside the PI tag of the document :)
	// PHP <?php ?> PI on first line.
	var LineNum = 0;
	var topLine = active.Lines(LineNum);
	var PHPLine = /<\?php/;
	if (PHPLine.test(topLine)) {
		LineNum = 1;
		if (curExt == "php" || curExt == "inc" || curExt == "fnc" || curExt == "class") {
			var PHPLang = /LANGUAGE ?= ?"?(php)/i;
			if (PHPLang.test(topLine)) {
				switch(RegExp.$1.toLowerCase()) {
					case "php":
					case "inc":
					case "fnc":
					case "class":
						headerBegin = "<?php\n";
						headerEnd = "?>\n";
						break;
					default:
						headerBegin = "<?php\n";
						headerEnd = "?>\n";
					}
				}
			}
		}
	
	// Does the header already exist in this file?

	//our header:
	/* $Id: config.inc.php,v 1.62 2001/12/23 23:05:23 lem9 Exp $ */
	var ThisHead = REFormat(headerBegin);
	var ThisUser = WSHNetwork.UserName;
	var ThisFile = REFormat(app.ExtractFileName(curFile));
	var ThisFoot = REFormat(headerEnd);

	var REHeader = eval("/" + ThisHead + " " + ThisFile + ",v(( )?(\\d{1,}\\.\\d{1,})?) (\\d{4}\\/\\d{2}\\/\\d{2} \\d{2}\\:\\d{2}\\:\\d{2}) " + ThisUser + ThisFoot + "([^\\n]*)/");

	/*
	* RegEx to "detect" the revision number -
	*/
	var verTest = eval("/(,v)(( )?(\\d{1,}\\.\\d{1,})?)/");	
	if (verTest.test(active.Text)) {
		/*
		* increment and return/append to "new" minor revision -
		*/
		if (RegExp.$2 != " ") {
			var tmpRev = RegExp.$2;
				tmpRev = tmpRev.split(".");
			var majRev = tmpRev[0];
			var minRev = tmpRev[1];
				minRev++;
			var newRev = majRev + "." + minRev;
			
			var ThisVer = RegExp.$1 + newRev;//RegExp.$2;
			}
		else {
			/*
			* no revision number found, leave as is.
			*/
			var ThisVer = RegExp.$1;
			}
		}
	else {
		/*
		* no revision found, assume revision 1.0
		*/
		var ThisVer = ",v1.0";
		}

	//this regex needs to "detect" the "v" (version) flag, date, username.
	
	// Remember cursor position.
	// Use ScriptX to invoke by reference (built into HS 4.01)
	var objScriptX = new ActiveXObject("ScriptX.Factory");
	var DateStamp = createDateString();
	var args = new Array(0,0);
	objScriptX.js.InvokeByRef(active, "GetCaretPos", args);	

	if (REHeader.test(active.Text)) {
		insertString += headerBegin + " ";
		insertString += app.ExtractFileName(curFile) + ThisVer;
		insertString += " " + DateStamp + " ";
		insertString += WSHNetwork.UserName;
		insertString += headerEnd;

		active.Text = active.Text.replace(REHeader, insertString);
		
		// restore the cursor position
		active.SetCaretPos(args[0], args[1]);
		app.StatusWarning("CVS Header Updated -- " + ThisFile + ThisVer);
		}
	else {
		insertString += headerBegin + " ";
		insertString += app.ExtractFileName(curFile) + ThisVer;
		insertString += " " + DateStamp + " ";
		insertString += WSHNetwork.UserName;
		insertString += headerEnd + "\n";
	
		active.Lines(LineNum) = insertString + active.Lines(LineNum);
		
		// restore the cursor position
		active.SetCaretPos(args[0], args[1]);
		app.StatusWarning("CVS Header Inserted -- " + ThisFile + ThisVer);
		}

	WSHNetwork = null;
	objScriptX = null;
	}

function REFormat(string) {
	var badChars = /([\/\\\*\[\]\\$\?\.\(\)\+])/g;
	return string.replace(badChars, "\\\$1");
	}
	
function createDateString() {
	var dateStamp = new Date();
	//return the [Day of the Week]
	//build the physical date [22nd]
	var Today = dateStamp.getDate();
	if (Today <= 9) { 
		var Today = "0"+Today; 
		}

	//return the [Date]	
	var theMonth = dateStamp.getMonth()+1;
	var Month = theMonth; //display month as single digit num where applic.
	if (theMonth <= 9) { 
		var Month = "0"+theMonth; 
		}

	//return the [Month]
	//build the Year
	var Year = dateStamp.getFullYear();

	//build the Clock
	var hours 	= dateStamp.getHours();
	var minutes = dateStamp.getMinutes();
	var seconds = dateStamp.getSeconds();

	if (hours <= 9) { 
		var hours = "0"+hours; 
		}
	else { 
		var hours = hours; 
		}

	if (minutes <= 9) { 
		var minutes = "0"+minutes; 
		}
	if (seconds <= 9) { 
		var seconds = "0"+seconds; 
		}

	//2001/12/23 23:05:23
	return Year+"/"+Month+"/"+Today+" "+hours+":"+minutes+":"+seconds;
	}

